#!/bin/bash
dir=$(cd "$(dirname "$0")"; pwd)
if [ ! -d $dir/logs ];then
    mkdir $dir/logs
fi
log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}

log_print "backup crontab is runing!" 

executable_user=seekcy
if [ $(whoami) != $executable_user ]; then
    log_print "please login user $executable_user to execute this script"
    exit
fi

source /home/seekcy/.bash_profile

sh $dir/open_redis_backup.sh

sh $dir/open_mongo_backup.sh

sh $dir/open_mysql_backup.sh

#sh $dir/open_influxdb_backup.sh


log_print "backup crontab is finish!" 