#!/bin/bash
file_num=2 #备份文件超过3个删除
influx_host="127.0.0.1"
influx_port="26317"
influx_user="admin" #InfluxDB备份用户
influx_password="SeekcyWWYTInflux" #InfluxDB备份用户的密码`
influx_db="js_open_location" #要备份的数据库名称
influx_backup_time=`date +%Y%m%d%H%M%S`  #定义备份详细时间

source /home/seekcy/.bash_profile

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
influx_backup_dir="$dir/data/influxDB"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use InfluxDB backup tools!"
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" 

space=`df -m /home/seekcy/ |awk '{print $4}'`
space=${space/Available/}
data_g=$[space/1024]
if [[ $data_g -le 30 ]]; then 
        log_print "ERROR:this directory（/home/seekcy/） is less than 30G，Stop execution!"
        exit
fi


# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z $influx_user ] || [ -z $influx_password ] || [ -z $influx_host ] || [ -z $influx_port ];then
	log_print "ERROR:Please fill influxDB connect info in open_influxdb_backup.sh"
	exit
fi


# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z "$influx_backup_dir" ];then
	log_print "ERROR:Please fill influx_backup_dir in open_influxdb_backup.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z "$influx_db" ];then
	log_print "ERROR:Please fill influx_db in open_influxdb_backup.sh"
	exit
fi


# 判断influx是否启动,influx没有启动则备份退出
influx_ps=`ps -ef |grep influxdb |wc -l`
influx_listen=`netstat -an |grep LISTEN |grep $influx_port|wc -l`
if [[ $influx_ps -le 1 ||  $influx_listen == 0 ]]; then
        log_print "ERROR:influxdb is not running! backup stop!"
        exit
fi

#判断文件夹是否存在
if [[ ! -d "$influx_backup_dir" ]]; then
	`mkdir -p $influx_backup_dir`
	log_print "create $influx_backup_dir success"
else
	#删除已备份数据
	num_all=`ls -l $influx_backup_dir |grep "^d"|wc -l`
	if [[ $num_all -ge $file_num ]];then
		num=$[num_all-file_num]
		for i in `ls -trF $influx_backup_dir | grep '/$'| head -n $num`	
		do
			`rm -rf $influx_backup_dir/$i`
			log_print "delete $influx_backup_dir/$i complete!"
		done
		log_print "Expired $num num backup files delete complete!"
	fi
fi
# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$influx_db" != "" ];then
		if [[ ! -z "$1" ]];then
			backup_date=`date -d "-$1 day ago" +%Y-%m-%dT%H:%M:%SZ`
			log_print "database $influx_db backup $1 day collection start..."

			influxd backup -portable -database $influx_db -start $backup_date $influx_backup_dir/$influx_db-$influx_backup_time/
		else
			log_print "database $influx_db backup all collection start..."
			
			influxd backup -portable -database $influx_db $influx_backup_dir/$influx_db-$influx_backup_time/
		fi
		flag=`echo $?`
		if [ $flag == "0" ];then
			log_print "database $influx_db backup to $influx_backup_dir/$influx_db-$influx_backup_time success!"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			log_print "InfluxDB backup success !"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		else
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			log_print "database $influx_db backup fail!"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		fi  
else
		log_print "ERROR:No database to backup! backup stop!"
fi