#!/bin/bash
influx_user="admin" #InfluxDB备份用户
influx_password="SeekcyWWYTInflux" #InfluxDB备份用户的密码`
influx_host="127.0.0.1"
influx_port="26317"
influx_restore_db="js_open_location" #要备份的数据库名称
influx_welcome_msg="Welcome to use InfluxDB restore tools!"

source /home/seekcy/.bash_profile

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
influx_backup_dir="$dir/data/influxDB"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use InfluxDB restore tools!"
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" 

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z $influx_user ] || [ -z $influx_password ] || [ -z $influx_host ] || [ -z $influx_port ];then
	log_print "ERROR:Please fill influx connect info in open_influxdb_restore.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$influx_backup_dir" == "" ];then
	log_print "ERROR:Please fill influx_backup_dir in open_influxdb_restore.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$influx_restore_db" == "" ];then
	log_print "ERROR:Please fill influx_restore_db in open_influxdb_restore.sh"
	exit
fi

# 判断influxdb是否启动,influxdb没有启动则备份退出
influx_ps=`ps -ef |grep /home/seekcy/database/influxdb |wc -l`
influx_listen=`netstat -an |grep LISTEN |grep $influx_port|wc -l`
if [ [$influx_ps == 0] -o [$influx_listen == 0] ]; then
        log_print "ERROR:influxdb is not running! restore stop!"
        exit
fi

#判断文件是否存在
if [[ ! -d "$influx_backup_dir/" ]]; then
	log_print "restore data is not exist,restore database fail!"	
	exit
fi

last_dri=`ls -tF $influx_backup_dir | grep '/$'| head -n 1`
if [ ! -d $influx_backup_dir/$last_dri ];then	
	log_print "restore data is not exist,restore database fail!"	
	exit
fi

influx -precision rfc3339 -port $influx_port -username $influx_user -password $influx_password -execute "drop database $influx_restore_db"

log_print "database $influx_restore_db restore start..."

influxd restore -portable -db $influx_restore_db $influx_backup_dir/$last_dri

flag=`echo $?`
if [ $flag == "0" ];then
		log_print "$influx_backup_dir/$last_dri restore to database $influx_restore_db success!"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		log_print "InfluxDB restore success !"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
else
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		log_print "database $influx_restore_db restore fail!"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
fi