#!/bin/bash
file_num=2 #备份文件超过3个删除
mongo_host="127.0.0.1"
mongo_port="47017"
mongo_user="jsopen" #mongo备份用户
mongo_password="JsOpenMongo2019" #mongo备份用户的密码`
mongo_db="js_open_location_server" #要备份的数据库名称
mongo_backup_time=`date +%Y%m%d%H%M%S`  #定义备份详细时间

source /home/seekcy/.bash_profile

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
mongo_backup_dir="$dir/data/mongo"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use mongo backup tools !"
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z $mongo_user ] || [ -z $mongo_password ] || [ -z $mongo_host ] || [ -z $mongo_port ];then
	log_print "ERROR:Please fill mongo connect info in open_mongo_backup.sh"
	exit
fi


# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z "$mongo_backup_dir" ];then
	log_print "ERROR:Please fill mongo_backup_dir in open_mongo_backup.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z "$mongo_db" ];then
	log_print "ERROR:Please fill mongo_db in open_mongo_backup.sh"
	exit
fi



# 判断mongo是否启动,mongo没有启动则备份退出
mongo_ps=`ps -ef |grep mongodb |wc -l`
mongo_listen=`netstat -an |grep LISTEN |grep $mongo_port|wc -l`
if [[ $mongo_ps -le 1 ||  $mongo_listen == 0 ]]; then
        log_print "ERROR:mongo is not running! backup stop!"
        exit
else
        log_print "MongoDB backup start >>"
fi

#判断文件夹是否存在
if [[ ! -d "$mongo_backup_dir" ]]; then
	`mkdir -p $mongo_backup_dir`
	log_print "create $mongo_backup_dir success"
else
	#删除已备份数据
	num_all=`ls -l $mongo_backup_dir |grep "^d"|wc -l`
	if [[ $num_all -ge $file_num ]];then
		num=$[num_all-file_num]
		for i in `ls -trF $mongo_backup_dir | grep '/$'| head -n $num`	
		do
			`rm -rf $mongo_backup_dir/$i`
			log_print "delete $mongo_backup_dir/$i complete!"
		done
		log_print "Expired $num num backup files delete complete!"
	fi
fi
# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$mongo_db" != "" ];then
		log_print "database $mongo_db backup all collection start..."
			`mongodump -h $mongo_host:$mongo_port -u $mongo_user -p $mongo_password -d $mongo_db --gzip  -o $mongo_backup_dir/$mongo_db-$mongo_backup_time/`

		flag=`echo $?`
		if [ $flag == "0" ];then
			log_print "database $mongo_db backup to $mongo_backup_dir/$mongo_db-$mongo_backup_time.gz success!"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			log_print "MongoDB backup success !"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		else
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			log_print "database $backup_db backup fail!"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		fi  
else
		log_print "ERROR:No database to backup! backup stop!"
fi