#!/bin/bash
mongo_user="jsopen" #mongo备份用户
mongo_password="JsOpenMongo2019" #mongo备份用户的密码`
mongo_host="localhost"
mongo_port="47017"
mongo_restore_db="js_open_location_server" #要备份的数据库名称

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
mongo_restore_dir="$dir/data/mongo"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use mongo restore tools !"
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ -z $mongo_user ] || [ -z $mongo_password ] || [ -z $mongo_host ] || [ -z $mongo_port ];then
	log_print "ERROR:Please fill mongo connect info in open_mongo_restore.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$mongo_restore_dir" == "" ];then
	log_print "ERROR:Please fill mongo_restore_dir in open_mongo_restore.sh"
	exit
fi

# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
if [ "$mongo_restore_db" == "" ];then
	log_print "ERROR:Please fill mongo_restore_db in open_mongo_restore.sh"
	exit
fi

# 判断mongo是否启动,mongo没有启动则备份退出
mongo_ps=`ps -ef |grep /home/seekcy/database/mongodb |wc -l`
mongo_listen=`netstat -an |grep LISTEN |grep $mongo_port|wc -l`
if [ [$mongo_ps == 0] -o [$mongo_listen == 0] ]; then
        log_print "ERROR:mongo is not running! restore stop!"
        exit
fi

#判断文件是否存在
if [[ ! -d "$mongo_restore_dir/" ]]; then
	log_print "restore data is not exist,restore database fail!"	
	exit
fi

last_dri=`ls -tF $mongo_restore_dir | grep '/$'| head -n 1`
if [ ! -d $mongo_restore_dir/$last_dri ];then	
	log_print "restore data is not exist,restore database fail!"	
	exit
fi

log_print "database $mongo_restore_db restore start..."
`mongorestore -h $mongo_host:$mongo_port -u$mongo_user -p$mongo_password -d $mongo_restore_db --drop --gzip $mongo_restore_dir/$last_dri$mongo_restore_db`
flag=`echo $?`
if [ $flag == "0" ];then
		log_print "$mongo_restore_dir/$last_dri$restore_d restore to database $mongo_restore_db success!"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		log_print "MongoDB restore success !"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
else
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
		log_print "database $mongo_restore_db restore fail!"
		log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
fi