#!/bin/bash
file_num=2 #备份文件超过3个删除
mysql_host="localhost"
mysql_port="26316"
mysql_user="root" #MySQL备份用户
mysql_password="Password2017" #MySQL备份用户的密码`
mysql_charset="utf8"
mysql_backup_db="js_open_location_server" #要备份的数据库名称
mysql_backup_time=`date +%Y%m%d%H%M%S`  #定义备份详细时间
seekcy_mysql_sock=`ls -l /home/seekcy/database/mysql/mysql.sock | wc -l`
tmp_mysql_sock=`ls -l /tmp/mysql.sock | wc -l`
mysqldump=/home/seekcy/database/mysql/bin/mysqldump

source /home/seekcy/.bash_profile

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
mysql_backup_dir="$dir/data/mysql"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}

log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use MySQL backup tools!" 
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

space=`df -m /home/seekcy/ |awk '{print $4}'`
space=${space/Available/}
data_g=$[space/1024]
if [[ $data_g -le 30 ]]; then
    log_print "ERROR:this directory（/home/seekcy/） is less than 30G，Stop execution!"
    exit
fi


if [ -z $mysql_user ] || [ -z $mysql_password ] || [ -z $mysql_host ] || [ -z $mysql_port ];then
	log_print "ERROR:Please fill mysql connect info in open_mysql_backup.sh"
	exit
fi


if [ -z "$mysql_backup_dir" ];then
	log_print "ERROR:Please fill mysql_backup_dir in open_mysql_backup.sh"
	exit
fi


if [ -z "$mysql_backup_db" ];then
	log_print "ERROR:Please fill mysql_backup_db in open_mysql_backup.sh"
	exit
fi


 if [[ $seekcy_mysql_sock -eq 1 && $tmp_mysql_sock -eq 0 ]]; then
  	ln -s /home/seekcy/database/mysql/mysql.sock /tmp/mysql.sock
 fi

	# 判断MYSQL是否启动,mysql没有启动则备份退出
	mysql_ps=`ps -ef |grep /home/seekcy/database/mysql  | grep -v grep |wc -l`
	if [ $mysql_ps -lt 1 ]; then
	        log_print "ERROR:MySQL is not running! backup stop!"
	        exit
	else
	        log_print "Mysql backup start >>"
	fi

	# 连接到mysql数据库，无法连接则备份退出
	/home/seekcy/database/mysql/bin/mysql -S /home/seekcy/database/mysql/mysql.sock -h$mysql_host -P$mysql_port -u$mysql_user -p$mysql_password <<end
	use mysql;
	select host,user from user where user='root' and host='localhost';
	exit
end

	flag=`echo $?`
	if [ $flag != "0" ]; then
	        log_print "***************ERROR:Can't connect mysql server! backup stop!***************"
	        log_print "if error msg is 'ERROR 2002 (HY000): Can't connect to local MySQL server through socket '/tmp/mysql.sock' (2)', you can run 'ln -s /home/seekcy/database/mysql/mysql.sock /tmp/mysql.sock'"
	        exit
	fi
	#创建文件夹
	if [[ ! -d "$mysql_backup_dir" ]]; then
		mkdir -p $mysql_backup_dir
		chmod 777 $mysql_backup_dir
		log_print "create $mysql_backup_dir success"
	else
		`find $mysql_backup_dir -name '*.sql' |xargs rm -rf`
		log_print "delete all database backup .sql file complete!"
		#删除已备份数据
		num_all=`find $mysql_backup_dir -name '*.gz' | wc -l`
		if [[ $num_all -gt $file_num ]];then
			num=$[num_all-file_num]
			for i in `ls -frt $mysql_backup_dir |grep '.gz$'| head -n $num`
			do
				`rm -rf $mysql_backup_dir/$i`
				log_print "delete $mysql_backup_dir/$i complete!"
			done;
			log_print "Expired $num num '.gz' backup files delete complete!"
		fi
	fi
	# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
	if [ "$mysql_backup_db" != "" ];then
			log_print "database $mysql_backup_db backup all collection start..."

			`/home/seekcy/database/mysql/bin/mysqldump -S /home/seekcy/database/mysql/mysql.sock -h$mysql_host -P$mysql_port -u$mysql_user -p$mysql_password $mysql_backup_db --default-character-set=$mysql_charset | gzip > $mysql_backup_dir/$mysql_backup_db-$mysql_backup_time.sql.gz`
			
			flag=`echo $?`
			if [ $flag == "0" ];then
				log_print "database $mysql_backup_db backup to $mysql_backup_dir/$mysql_backup_db-$mysql_backup_time.sql.gz success!"
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
				log_print "Mysql backup success !"
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			else
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
				log_print "database $mysql_backup_db backup fail!"
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			fi  
	else
	  log_print "ERROR:No database to backup! backup stop"
	fi
