#!/bin/bash
mysql_user="root" #MySQL备份用户
mysql_password="Password2017" #MySQL备份用户的密码`
mysql_host="localhost"
mysql_port="26316"
mysql_charset="utf8"
mysql_restore_db="js_open_location_server" #要备份的数据库名称
file_date=""

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
mysql_restore_dir="$dir/data/mysql"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}

log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use MySQL restore tools!" 
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

if [ -z $mysql_user ] || [ -z $mysql_password ] || [ -z $mysql_host ] || [ -z $mysql_port ];then
	log_print "ERROR:Please fill mysql connect info in open_mysql_restore.sh"
	exit
fi

if [ -z "$mysql_restore_dir" ];then
	log_print "ERROR:Please fill mysql_restore_dir in open_mysql_restore.sh"
	exit
fi

if [ -z "$mysql_restore_db" ];then
	log_print "ERROR:Please fill mysql_restore_db in open_mysql_restore.sh"
	exit
fi


# 判断MYSQL是否启动,mysql没有启动则备份退出
mysql_ps=`ps -ef |grep /home/seekcy/database/mysql |wc -l`
mysql_listen=`netstat -an |grep LISTEN |grep $mysql_port|wc -l`
if [ [$mysql_ps == 0] -o [$mysql_listen == 0] ]; then
        log_print "ERROR:MySQL is not running! restore stop!"
        exit
fi


#解压压缩文件
gunzip_data(){
   file=`find $mysql_restore_dir -name '*.gz' | xargs ls -lt |awk '{print $9}'| head -n 1`
   if [[ ! -f $file ]];then
	   log_print "backup data is not exist,restore database fail!"
	   exit
	else
		file_end=`echo ${file##*js_open_location_server-}`
		file_date=`echo ${file_end%.sql*}`
		`gzip -dc $file > $mysql_restore_dir/$mysql_restore_db-$file_date.sql`
		log_print "gunzip $file to $mysql_restore_db-$file_date.sql success!"
	fi	
}


# 连接到mysql数据库，无法连接则备份退出
mysql -h$mysql_host -P$mysql_port -u$mysql_user -p$mysql_password <<end
use mysql;
select host,user from user where user='root' and host='localhost';
exit
end



flag=`echo $?`
if [ $flag != "0" ]; then
        log_print "ERROR:Can't connect mysql server! restore stop!"
        exit
else
	#判断文件是否存在
	if [[ ! -f "$mysql_restore_dir/$mysql_restore_db.sql" ]]; then
		gunzip_data
	else
		`find $mysql_restore_dir -name '*.sql' | xargs ls -ltr |awk '{print $9}'|xargs rm -rf`
		log_print "delete database backup .sql file complete!"
		gunzip_data
	fi
	# 判断有没有定义备份的数据库，如果定义则开始备份，否则退出备份
	if [ "$mysql_restore_db" != "" ];then
			log_print "database $mysql_restore_db restore start..."
			`mysql -u$mysql_user -p$mysql_password $mysql_restore_db < $mysql_restore_dir/$mysql_restore_db-$file_date.sql`
			flag=`echo $?`
			if [ $flag == "0" ];then
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
				log_print "$mysql_restore_dir/$mysql_restore_db.sql restore to database $mysql_restore_db-$file_date success!"
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			else
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
				log_print "database $mysql_restore_db restore fail!"
				log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			fi  
	else
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
			log_print "ERROR:No database to restore! restore stop"
			log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
	fi
fi