#!/bin/bash
redis_restore_db="/home/seekcy/softs/" #备份数据存放位置
redis_restore_table="dump.rdb"  #备份数据文件名称

dir=$(cd "$(dirname "$0")"; pwd)

log_file_dir=$dir/logs/$(date +"%Y-%m-%d")".log"
redis_restore_dir="$dir/data/redis/"  #备份数据存放位置

function log_print()
{
    time=$(date +"%Y-%m-%d %H:%M:%S")
    write_str="$time $* "
    echo $write_str >> $log_file_dir
}
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
log_print "Welcome to use redis restore tools!"
log_print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

if [ -z "$redis_restore_dir" ];then
	log_print "ERROR:Please fill redis_restore_dir in open_redis_restore.sh"
	exit
fi

if [ -z "$redis_restore_db" ];then
	log_print "ERROR:Please fill redis_restore_db in open_redis_restore.sh"
	exit
fi

if [ -z "$redis_restore_table" ];then
	log_print "ERROR:Please fill redis_redis_restore_db in open_redis_restore.sh"
	exit
fi


#判断文件是否存在
data=`find $redis_restore_dir -name '*'$redis_restore_table | xargs ls -ltr |awk '{print $9}'|head -n 1`
if [[ $data == "" ]]; then
	log_print "restore data is not exist,restore database fail!"	
	exit
fi	

rm -rf $redis_restore_db$redis_restore_table
cp $data $redis_restore_db$redis_restore_table
log_print "update database backup $redis_restore_db$redis_restore_table file success!"
	
redis_res=`ps aux | grep redis-server | grep -v grep | wc -l`;
redis_id=`ps -ef|grep redis-server |grep -v 'grep'  | awk '{print $2}'`;
redis_server=`find /home/seekcy/ -name redis-server | xargs ls -ltr |awk '{print $9}'`;
redis_conf=`find /home/seekcy/ -name redis_26312.conf | xargs ls -ltr |awk '{print $9}'`;
run_num=0
if [[ $redis_res  -eq  0 ]]; then
    log_print "redis is not running! restart it!"
    $redis_server $redis_conf > /dev/null 2>&1 &
    log_print "restore redis database success!"
    exit
else
    log_print "redis is running! restart it!"
    log_print $redis_id
   `kill -9 $redis_id` 
    sleep 1s
    `$redis_server $redis_conf > /dev/null 2>&1 &`
    log_print "restore redis database success!"
fi